
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>12.文件系统——磁盘管理之RAID概述 / 憋错料</title>

    <meta name="description" content="12.文件系统——磁盘管理之RAID概述 一.什么是RAID 从上个世纪80年代起,主流的硬盘接口主要有两类: A.IDE:用于桌面系统 B.SCSI:用于工业系统(因为转速高,平均巡道时间短,性能较IDE好) SCSI的性能虽然优于IDE,但其成本约是IDE的五倍以上,故无法广泛应用.人们为了节省成本的同时保持性能,于是设计出了一种方案,即将很多廉价的IDE设备联合起来,当做一块硬盘使用.这种将多块廉价IDE设备并行联合使用的模式就是RAID--廉价冗余磁盘阵列(Redundent Array ofInexpensive Disk).">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">12.文件系统——磁盘管理之RAID概述</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p><strong>一、什么是RAID</strong></p>
<p>从上个世纪80年代起，主流的硬盘接口主要有两类：</p>
<p>A.IDE：用于桌面系统</p>
<p>B.SCSI：用于工业系统（因为转速高，平均巡道时间短，性能较IDE好）</p>
<p>SCSI的性能虽然优于IDE，但其成本约是IDE的五倍以上，故无法广泛应用。人们为了节省成本的同时保持性能，于是设计出了一种方案，即将很多廉价的IDE设备联合起来，当做一块硬盘使用。这种将多块廉价IDE设备并行联合使用的模式就是RAID——廉价冗余磁盘阵列（Redundent Array ofInexpensive Disk）。</p>
<p>RAID能够让多块廉价的硬盘并行工作，在一定程度上提供了高效、可靠的特点。但它需要在IDE控制器之上再提供一种逻辑更高的控制器，这种控制器即为RAID控制器。IDE设备虽然廉价，但是RAID控制器本身非常昂贵，且RAID模式所提供的可靠性不足以满足人们的需要，所以后来在工业级别的应用上，人们将SCSI联合起来组成了RAID，这种RAID得到了更广泛的应用。此时RAID廉价的特性已经不明显了，于是其含义变成了：RedundentArray of Independent Disk——独立冗余磁盘阵列。当让无论RAID的名称如何变化，它体现的思想都是一致的，即将底层的物理磁盘在更高层次的架构上组织起来，使它们能像一块完整的物理设备那样工作。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDIvNDUvM0Yvd0tpb0wxUGs1bURSRzlJMEFBQkRhNWRYNnM0NzM1LnBuZw==.jpg" /></p>
<p>在没有RADI之前，每一个单独的设备，其控制器是直接连接到主板的总线上的，这个控制器可以和CPU及其他设备进行通信；而有了RAID级别的概念之后，需要在原有控制器之上附加一个更高级别的总控制器，该控制器会对其他低级别的控制器进行集中控制，然后再连接到内存、CPU或其他设备的总线上。</p>
<p>在没有使用RAID之前，CUP会将每一个设备识别为一个单独的个体，而有了RAID之后，CPU会认为这几个设备是一个整体，即由RAID控制器抽象出来的设备。对RAID的管理，就是对总控制器（RAID的芯片）的管理，这个芯片可能是内嵌在主板上的，也可能是个独立的卡片——适配器，通过PCI-E的插槽连接到一个存储设备上，该存储设备称为DAS设备（直接附加存储设备）。</p>
<p><strong>二、RAID</strong><strong>的级别</strong></p>
<p>RAID的目的主要有两个方面：</p>
<p>A、高性能：所谓高性能指的是读写性能，有的场景要求读性能高，有的场景要求写性能高，还有一些场景需要同时兼顾读写的性能</p>
<p>B、可靠性（冗余）：频繁的读写操作容易损坏磁盘，可靠性就意味着即使某一块磁盘坏掉了，也不会影响数据的使用（有备份硬盘），这种概念即为冗余。</p>
<p>为了满足不同高性能和可靠性的需求，RAID提供了不同的级别，而区分不同RAID级别的方式，就是在RAID后面加上不同的数字，即从Raid0,Raid1,...Raid7这8种；而后来随着RAID的进一步发展，产生了不同的RAID级别的组合方式，即Raid10,Raid50等等。</p>
<p>RAID的级别本身没有高低上下之分，也就意味着Raid1并不会优于Raid0，它们只是用来描述多块磁盘的组合方式。下面来逐一介绍不同RAID级别的组合方式：</p>
<p><strong>（1）</strong><strong>Raid0</strong></p>
<p>Raid0也称为条带设备，即将多块设备并联起来提供高性能的方式。RAID0以条带的形式将数据均匀分布在阵列的各个磁盘上，D0、D1...个数据块并不是指的Block，数据块要大得多。每个数据块会按照顺序分别存储到对应的硬盘数据块上，故在RAID0上存储数据，是将数据平均分布到磁盘上，从而实现了并行存取，因此（读写）性能得到了极大的提升。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDIvNDUvM0Yvd0tpb20xUGs1YTZqVnZDTUFBSHFtZFRCUFBzMTUyLmpwZw==.jpg" /></p>
<p><strong>RAID0</strong><strong>的特性</strong></p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDAvNDUvM0Yvd0tpb0wxUGs1enlqNEtDeEFBQk9JNzRacmtNNTE1LnBuZw==.jpg" /></p>
<p><strong>（2）</strong><strong>Raid1</strong></p>
<p>Raid1也称为镜像，镜像顾名思义就是将一份数据存储多份，以镜像为冗余方式，对虚拟磁盘上的数据做多份拷贝，放在成员磁盘上。如果一块物理磁盘坏了，另一块还能继续提供服务。对于Raid1来说，它仍然需要将数据切割为数据块。对于镜像设备来说，两个或多个磁盘上的位（扇区），都是一一对应的。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDAvNDUvM0Yvd0tpb0wxUGs1NEt6amYwTUFBRGg2Y3NIN2xZOTI1LmpwZw==.jpg" /></p>
<p>如果其中一块磁盘坏掉了，将由另一块磁盘继续提供服务；为了防止备份磁盘也坏掉，就需要马上将已经坏掉的磁盘用一块好的新盘替换掉，而当新磁盘替换上来后，它会马上和正在工作的磁盘做一次同步（Sync），即和原有磁盘建立对应关系，并将原有磁盘上的数据<strong>按位</strong>复制过来。所以做镜像服务的磁盘，需要时时监控。现在有很多RAID1提供热备份，即在镜像磁盘之外还有一块热备份磁盘，时时监控正在工作的镜像磁盘，一旦发现其中任何一块磁盘坏了，就自动顶替上来，从而保证可靠性。</p>
<p><strong>RAID1</strong><strong>的特性</strong></p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDEvNDUvNDAvd0tpb0wxUGs1OFNUWGcyNEFBQk1vV1hLYTlJMjU5LnBuZw==.jpg" /></p>
<p><strong>（3）</strong><strong>Raid2</strong></p>
<p>Raid0性能高，但没有可靠性；Raid1提供了可靠性，但是牺牲了部分性能，因此为了兼顾性能和可靠，出现了Raid2。Raid2采用校验冗余：</p>
<p>1. 把数据分散为位或块，加入汉明码，间隔写入到磁盘阵列的每个磁盘中。它采用异或运算（两者相同为假，不同为真，可以用来还原数据），假设一个磁盘块上存的是1，另一个磁盘块上存的是0，那么其中一块坏了，可以根据好磁盘上的数据，和异或结果推断出坏磁盘上的数据。Raid2就是通过3块硬盘来实现校验冗余。</p>
<p>2. 在成员磁盘上的地址都一样</p>
<p>3. 采用了并行存取方式</p>
<p>4. 花费大，成本昂贵</p>
<p>Raid2在实际中使用不多。</p>
<p><strong>（4）</strong><strong>Raid3</strong></p>
<p>在RAID3中，数据块再次分割为更小的块并行传输到各个成员磁盘上，同时计算异或校验数据，存放到专用的校验磁盘上，它和RAID2差距并不大，其存储方式比较复杂，使用也不多。</p>
<p><strong>RAID3</strong><strong>的特性</strong></p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDAvNDUvM0Yvd0tpb20xUGs1eFBTbXNUY0FBQlVzLWV4SnprMjgzLnBuZw==.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDAvNDUvM0Yvd0tpb20xUGs1elhDWm9oTkFBSEJCQ2hrdlRNMzExLmpwZw==.jpg" /></p>
<p><strong><br /></strong></p>
<p><strong>（5）</strong><strong>Raid4</strong></p>
<p>在Raid4中，数据被分为更大的块，并行传输到各个成员磁盘上，同时计算异或校验数据，存放到专用的校验磁盘上。RAID4采用独立存取方式，将条带由RAID3的小数据块改为更大的数据块，这是RAID4和RAID3最大的不同。</p>
<p>RAID4的校验较为迅速，可以获得相对于RAID3更高的读取速度，但写入速度极差，控制器的设计更加复杂，故也不常用。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDIvNDUvNDAvd0tpb0wxUGs2TmZUajNVdkFBSVV0eVhiaEEwNTYzLmpwZw==.jpg" /></p>
<p><strong>（6）</strong><strong>Raid5</strong></p>
<p>RAID5采用独立存取的阵列方式，校验信息被均匀的分散到阵列的各个磁盘上，没有哪一块磁盘是专门用来存放校验信息的，所以单个校验数据不会成为吞吐量的瓶颈。因此RAID5融合了RAID4的优点，同时避免了RAID4的缺陷，使用较为广泛。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDEvNDUvM0Yvd0tpb20xUGs1X1RBcXNHbkFBSk9MYnZVaHJzODc2LmpwZw==.jpg" /><strong>RAID5的特性</strong></p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDEvNDUvNDAvd0tpb0wxUGs2VU9ENWVCN0FBQkg0Rl9id3FBMjU2LnBuZw==.jpg" /></p>
<p><strong>（7）</strong><strong>Raid6</strong></p>
<p>RAID6是指带有两种分布存储的检验信息的磁盘阵列，它是对RAID5的扩展，主要是用于要求数据绝对不能出错的场合，使用了二种奇偶校验方法，需要N+2个磁盘。</p>
<p>常用的RAID6技术:</p>
<p><strong>A. RAID6 P</strong><strong>＋Q</strong>：根据公式计算出P和Q的值，当有两个数据同时丢失时，仍可以计算出原数据</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDIvNDUvM0Yvd0tpb20xUGs2R2FDZzhEYkFBQlJ4aWhpTW5RMTIzLnBuZw==.jpg" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<strong>B. RAID6 DP</strong>：DP中的DP指Double Parity，它在RAID4的基础上不仅有行的校验，还增加了一个用来存放斜向校验信息的磁盘</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDAvNDUvM0Yvd0tpb20xUGs2TE9pSnBXcEFBQkxtYjZtQlpVNTUxLnBuZw==.jpg" /></p>
<p><strong>（8）</strong><strong>Raid7</strong></p>
<p>RAID7是一种新的RAID标准，它与以前见到的RAID级别有明显的区别，可以理解成一个独立的“存储计算机”。RAID7自身带有智能化实时操作系统和用于存储管理的软件工具，可以完全独立与主机运行，不占用主机CPU资源。</p>

<p><P><A href="http://www.bubuko.com/infodetail-302500.html" rel="external nofollow noreferrer">12.文件系统——磁盘管理之RAID概述,布布扣,bubuko.com</A></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-20 15:24:19 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/linux-%e6%96%87%e4%bb%b6%e7%b3%bb%e7%bb%9f%e3%80%80raid/" title="linux 文件系统　raid">linux 文件系统　raid</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>12.文件系统——磁盘管理之RAID概述的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/35mwwE3.html" rel="bookmark">磁盘管理之raid阵列卡</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				磁盘管理之raid卡 使用raid卡的好处 1.获得更大的容量 2.获得更大的性能 3.获得更好的安全性 常用raid卡级别分类与区别 至少需要硬盘数 安全冗余 可用容量 性能 使用场景 举例 raid0 至少需要一块硬盘 最低 所有硬盘的总和 读写速度最快 不要求安全 只要求速度 raid1 只能两块硬盘 100% 两块硬盘容量的一半 写入速度慢 读取速度OK 只追求安全性 对速度没要求 raid5 至少三块硬盘 最多可以损坏一半 损失一块硬盘的容量 写入速度慢 读取速度OK 对速度要求不高			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MPWeAa4.html" rel="bookmark">linux下磁盘管理机制--RAID</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				RAID(Redundant Array Of Independent Disks):独立磁盘冗余阵列.RAID的最初出现的目的是为了解决中小型企业因经费原因使用不起SCSCI硬盘,而不得不使用像IDE较廉价的磁盘情况下,将多块IDE磁盘通过某种机制组合起来,使得IDE磁盘在一定程度上提高读写性能的一种机制.当然,现在也可以将SCSCI类的磁盘也可以做成RAID来提高磁盘的读写性能. 一.RAID的级别 RAID机制通过级别来RAID级别来定义磁盘的组合方式.常见的级别有:RAID0,RAID1			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MV7yPd0.html" rel="bookmark">磁盘管理之RAID</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				RAID(Reduntdant Arrays of Independent Disk),中文意思为磁盘阵列.自从加州伯克利分校1988年发布论文&quot;A Case for Redundant Array of Independent Disk&quot;,其本意是将多块廉价的磁盘通过某种方式组合在一起来使用,以提高磁盘的I/O能力和耐用性,其中提高I/O能力主要是通过&quot;并行读写&quot;和增加&quot;内存&quot;来实现,而提高耐用性主要是通过提高&quot;冗余能力&quot;来			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Z0K2XjM.html" rel="bookmark">23、磁盘管理&mdash;磁盘阵列&lpar;RAID&rpar;实例详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				磁盘阵列(RAID)实例详解 raid技术分类 软raid技术 硬raid技术 Raid和lvm的区别 为什么选择用raid RAID详解 RAID-0 RAID-1 RAID-5 Raid-10 Raid的管理 案例:创建一个raid10+冗余盘 磁盘阵列(RAID)实例详解 Raid(磁盘阵列)级别介绍 Raid有&quot;廉价磁盘冗余阵列&quot;的意思,就是利用多块廉价的硬盘组成磁盘组,让数据分部储存在这些硬盘里面,从而达到读取和写入加速的目的:也可以用作数据的冗余,当某块硬盘损毁后,其他硬盘			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/QM6WNG0.html" rel="bookmark">Linux入门之磁盘管理&lpar;7&rpar;RAID的实现</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				RAID(Redundant Arrays of Inexpensive Independent Disks)被称为廉价冗余阵列,为了提高磁盘的性能或者保存数据完整,将多个磁盘合成一个&quot;阵列&quot;来提供更好的性能.冗余等. RAID一般使用硬件raid,并配合指定 raid的接口或者raid卡来组成硬件raid,但是开销一般比较大,于是在linux中也提供了软件raid的实现. raid的好处: 提高IO能力: 磁盘的并行读写 提高耐用性: 磁盘冗余来实现 RAID技术分类: 多个磁盘组成			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/38bLkZM.html" rel="bookmark">Linux 磁盘管理 高级篇 -- quota&comma;RAID&comma;LVM</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1 概述 本文对配额,RAID,LVM的概念和具体创建过程做了介绍 2 配额 2.1 配额概念 在内核中执行 以文件系统为单位启用 对不同组或者用户的策略不同 根据块或者节点进行限制 执行软限制(soft limit) 硬限制(hard limit) 实现控制用户使用磁盘空间,防止某个用户无限制使用磁盘空间,对系统造成损害 配额要对磁盘独立分区进行控制,而且只能针对文件系统来进行配额,不能对文件夹进行控制,文件系统挂载选项要具备quota功能,在fstab里添加usrquota,grpquota			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MgeqE83.html" rel="bookmark">磁盘管理、进程管理、文件系统、软硬链接详细文档</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				项目技术操作文档项目名称:存储管理.进程管理 项目需求:1.在企业服务器上安装新硬盘,对磁盘进行分区.格式化.挂载处理2.根据企业服务器数据业务的不同,采用不同的raid技术来保证数据的读写速度.数据安全3.在企业的存储服务器上采用LVM逻辑卷技术来实现容量的动态调整4.在服务器的运维工作中随机对系统进程进行分析和管理 项目测试: 原理概述:存储管理是系统中必不可少的技术,Linux系统中支持多种存储管理技术.在企业服务器中需要根据业务的不同来分别使用分区.raid.LVM逻辑卷等技术. 测试环			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/XMgaXn3.html" rel="bookmark">磁盘管理之软RAID</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.RAID概述 RAID,Redundant Arrays of Inexpensive(Independent)Disks的简称,独立磁盘冗余阵列,简称磁盘阵列.简单来说,RAID是把多个硬盘组合成为一个逻辑扇区,因此,操作系统只会把它当作一个硬盘,经常被用在服务器电脑上.不同的RAID实现的功能也是不尽相同的,或增强处理速度,或增强容错能力,当然,更有甚者,是可以兼备这个特性的. 2.RAID分类 &lt;1&gt;RAID0 &lt;2&gt;RAID1 &lt;3&gt;RAID4 &lt;4&			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/n0lJNb4.html" rel="bookmark">linux基础学习-第十五天 磁盘管理（SWAP、dd、quota、RAID、LVM）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				2016-08-26: 授课内容: 1.SWAP交换分区的创建 2.dd命令的使用 3.设定文件系统配额 4.设定和管理软RAID设备 5.配置逻辑卷 1.swap (1)SWAP分区:模拟内存,当物理内存不足时,进程需要内存资源是,内存会把一部分没有在用的进程分页挪到硬盘的模拟内存中,腾出空间被现在需要使用内存资源的进程 即其作用是可以允许内存过载使用,windows系统也有类似的机制,由于虚拟内存空间是建立在硬盘之上,所以其速度和性能会大打折扣,所以适合临时使用 (2)创建SWAP分区: 相			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/r4J8AQ0.html" rel="bookmark" class="title">如何带好90后骚年</a>
					<div>
						除内容之外,也学习下别人的呈现方式吧.   阅读更多精彩,请关注公众号					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M68x9G3.html" rel="bookmark" class="title">ReportViewer报表</a>
					<div>
						个人感觉ReportViewer&gt;DataGridView&gt;listView 打开一个空的winform窗体程序,工具栏报表拖入 ReportViewer 在空的Form1中 在同一命名空 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47p7loM.html" rel="bookmark" class="title">canvas 之星空动画</a>
					<div>
						最近看到位博主的博客背景图很是炫酷,查找下资料了解是canvas实现效果,今天就来看看详细解剖下吧. 实现思路 首先了解下canvas中的动画原理?canvas中的动画其实是通过不断的重绘来实现动起来 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YGRpr4.html" rel="bookmark" class="title">linux文件系统管理及挂载</a>
					<div>
						文件系统的管理分区 sda0-7或者hda0-7 格式化就是设置文件系统 统计文件df -h 查看分区文件系统,使用空间,挂载点 -a查看特殊文件系统/proc /sysfs du -h /目录名   ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4Q86Zl3.html" rel="bookmark" class="title">css常用或不熟悉的</a>
					<div>
						css优先级: !important 〉  行内样式  &gt; id选择器  &gt; 类选择器|伪类选择器  &gt; 标签选择器  &gt;  通用选择器  &gt; 继承属性 综合优先级(只讨 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MP8qVBM.html" rel="bookmark" class="title">unity CommandBuffer学习</a>
					<div>
						unity官方的教程:https://blogs.unity3d.com/cn/2015/02/06/extending-unity-5-rendering-pipeline-command-buff ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0dAAvn3.html" rel="bookmark" class="title">noip模拟赛 好元素 哈希表的第一题</a>
					<div>
						这是一道关于 题2好元素 2s [问题描述] 小A一直认为,如果在一个由N个整数组成的数列{An}中,存在以下情况: Am+An+Ap = Ai (1 &lt;= m, n, p &lt; i &lt ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M62znyM.html" rel="bookmark" class="title">Billionaires</a>
					<div>
						Billionaires Time limit: 3.0 secondMemory limit: 64 MB You probably are aware that Moscow holds the  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0x5ewD3.html" rel="bookmark" class="title">POJ 3041 Asteroids &lpar;二分图最小点覆盖&rpar;</a>
					<div>
						题目链接:http://poj.org/problem?id=3041 在一个n*n的地图中,有m和障碍物,你每一次可以消除一行或者一列的障碍物,问你最少消除几次可以将障碍物全部清除. 用二分图将行( ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0Y7L6y4.html" rel="bookmark" class="title">微端 代码工程 as  air  分享</a>
					<div>
						分享 ^_^ 1. 用到 air , as , 2. 微端下载及更新技术 成功上线的棋牌游戏,可以用于传统游戏开发! 地址: http://download.csdn.net/detail/stone ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0ekxep4.html" rel="bookmark" class="title">SaltStack初始化系统</a>
					<div>
						目录规划如下: [[email protected] /srv]# tree  . ├── pillar │   ├── base │   │   ├── top.sls │   │   └── za ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0ekb1b4.html" rel="bookmark" class="title">任正非内部讲话：维持生存的根本就是不能腐败</a>
					<div>
						新浪科技讯 1月17日晚间消息,在上月初的华为监管体系座谈会上,任正非发表&lt;内外合规多打粮,保驾护航赢未来&gt;的讲话,强调监管工作的重要,表示维持生存的根本就是不能腐败:华为发展快而腐败少, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0a1NNk0.html" rel="bookmark" class="title">进制转换规则</a>
					<div>
						整型常量 1.八进制整常数八进制整常数必须以0开头,即以0作为八进制数的前缀.数码取值为0-7.八进制数通常是无符号数. 以下各数是合法的八进制数: 015(十进制为13) 0101(十进制为65)  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rbjOb3.html" rel="bookmark" class="title">mac和Xcode实用快捷键</a>
					<div>
						Mac和Xcode快捷键有很多,有些我们根本可以用鼠标快速完成,便于体现高大上的形象.整理了一些适合自己的快捷键: 1. Command + /    程序注释和反注释,选中一段代码之后,在按下.程序 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0l7ZQEM.html" rel="bookmark" class="title">杭电2044</a>
					<div>
						1 #include &lt;stdio.h&gt; 2 int main() 3 { 4 int i, j, n; 5 __int64 d[51] = {1, 1, 2,}; 6 for (i =  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0RmQJpM.html" rel="bookmark" class="title">2016&amp;quot&semi;百度之星&amp;quot&semi; - 初赛（Astar Round2A）All X&lpar;数学 矩阵&rpar;</a>
					<div>
						All X Accepts: 1281 Submissions: 7580 Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 65536/655 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lNVXB4.html" rel="bookmark" class="title">javascript原型链与特权方法</a>
					<div>
						&lt;pre name=&quot;code&quot; class=&quot;javascript&quot;&gt;function ClassA() { var value=4; this. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mobjgy4.html" rel="bookmark" class="title">Android 手势滑动的识别</a>
					<div>
						提要: 对于Android中的手势识别可以从以下三个Listener入手--OnTouchListener.OnGestureListener.OnDoubleTapListener.这三个监听器分别 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGAj6o3.html" rel="bookmark" class="title">windows amd64环境下使用arcpy发布web服务</a>
					<div>
						通常在安装arcgis的时候,arcgis desktop与arcgis server应该是必备软件 但他们使用的python却不同,desktop使用32位,server使用64位. 为了能将arc ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0bK95Y3.html" rel="bookmark" class="title">《Go语言实战》摘录：6&period;5 并发 - 通道</a>
					<div>
						6.5 通道					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.028 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
